﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using Infragistics.Win.UltraWinGrid;

namespace WindowsFormsApplication35
{
    public partial class Form1 : Form
    {
        DataTable dt;
        public Form1()
        {
            InitializeComponent();

            this.dt = new DataTable();
            for (int i = 0; i < 144; i++)
            {
                this.dt.Columns.Add("Column " + i.ToString());
            }

            for (int i = 0; i < 10; i++)            
            {
                DataRow row = this.dt.NewRow();
                foreach (DataColumn column in this.dt.Columns)
                    row[column] = column.ColumnName + ", " + i.ToString();

                this.dt.Rows.Add(row);
            }            
        }

        Stopwatch sw;
        private void button1_Click(object sender, EventArgs e)
        {
            this.sw = Stopwatch.StartNew();
            this.ultraGrid1.SetDataBinding(this.dt, null);
        }

        private void ultraGrid1_Paint(object sender, PaintEventArgs e)
        {
            if (this.sw != null)
            {
                this.sw.Stop();
                Debug.WriteLine(sw.Elapsed);
            }
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            UltraGridLayout layout = e.Layout;
            UltraGridBand band = layout.Bands[0];

            foreach (UltraGridColumn column in band.Columns)
            {
                if (column.Index > 19)
                    column.Hidden = true;
            }
        }
    }
}
